/******************************************************************************

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

******************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <string>
#include <sstream>
#include <functional>
#include <algorithm>

#include <xercesc/util/XMLString.hpp>

#include <boost/regex.hpp>

XERCES_CPP_NAMESPACE_USE

#define XMLcmp(x, y) XMLString::compareString(x, y)
#define XMLtr(x) XMLString::transcode(x)

namespace Utils {
     template<class T>
     T max(T t1, T t2) { return t1 < t2 ? t2 : t1; }
     
     template<class T>
     T min(T t1, T t2) { return t1 < t2 ? t1 : t2; }

     std::string escape(const std::string&);
     std::string unescape(const std::string&);

     struct toUpper {
	  char operator()(char chr) {
	       switch (chr) {
	       case '': return '';
	       case '': return '';
	       case '': return '';
	       default: break;
	       }
	       return toupper(chr);
	  }
     };

     struct toLower {
	  char operator()(char chr) {
	       switch (chr) {
	       case '': return '';
	       case '': return '';
	       case '': return '';
	       default: break;
	       }
	       return tolower(chr);
	  }
     };

     void lowercase(std::string&);
     void uppercase(std::string&);
}

#endif
